<h3>Registrar Publicación</h3>
<!-- <form #registroPublicacion> -->
<div class="form-row ">
    <div class="col-md-4 mb-2">
        <div class="input-group input-group-sm">
            <span class="input-group-text" style="min-width: 100px;">Plataforma</span>
            <select class="form-select form-select-sm" [(ngModel)]="plataforma" name="plataforma" [ngClass]="{'form-control':true,'is-invalid': registroPublicacion.submitted && plataforma == ''}">
                    <option selected disabled>Seleccione la Plataforma</option>
                    <option [value]="plataforma.plataforma_acronimo" *ngFor="let plataforma of catalogo_plataforma">{{plataforma.descripcion}}</option>
                </select>
            <div class="invalid-feedback">Seleccione la Plataforma</div>
        </div>
    </div>
    <div class="col-md-4 mb-2">
        <div class="input-group input-group-sm">
            <span class="input-group-text" style="width: 100px;">Fecha</span>
            <input type="date" class="form-control" [(ngModel)]="fecha_publicacion" name="fecha_publicacion" aria-describedby="inputGroupPrepend2" [ngClass]="{'form-date':true,'is-invalid': registroPublicacion.submitted && fecha_publicacion == ''}" required>
            <div class="invalid-feedback">La Fecha es Obligatorio</div>
        </div>
    </div>
</div>
<form (submit)="agregar(registroPublicacion)" #registroPublicacion="ngForm" novalidate>
    <div class="form-row ">
        <div class="col-md-4 mb-2">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">Identificador</span>
                <input type="text" class="form-control" [(ngModel)]="identificador" name="identificador" aria-describedby="inputGroupPrepend2">
                <div class="invalid-feedback"></div>
            </div>
        </div>
    </div>

    <div class="form-row ">
        <div class="col-md-12 mb-2">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">Titulo</span>
                <input type="text" class="form-control" [(ngModel)]="titulo" name="titulo" aria-describedby="inputGroupPrepend2" [ngClass]="{'is-invalid': registroPublicacion.submitted && titulo == '' }" required>
                <div class="invalid-feedback" *ngIf="titulo==''">Titulo no puede estar vacío</div>
            </div>
        </div>
    </div>
    <div class="form-row ">
        <div class="col-md-4 mb-2">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">Unidad</span>
                <input type="text" class="form-control" [(ngModel)]="unidad" name="unidad" aria-describedby="inputGroupPrepend2" [ngClass]="{'is-invalid': registroPublicacion.submitted && unidad == '' }" required>
                <div class="invalid-feedback" *ngIf="unidad==''">Unidad no puede estar vacío</div>
            </div>
        </div>
        <div class="col-md-4 mb-2">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">Clave Unidad</span>
                <input type="text" class="form-control" [(ngModel)]="sat_clave_unidad" name="sat_clave_unidad" list="catalogo_claves_unidad" aria-describedby="inputGroupPrepend2" [ngClass]="{'is-invalid': registroPublicacion.submitted && sat_clave_unidad == '' }" required>
                <datalist id="catalogo_claves_unidad">
                    <option [value]="elemento.clave_unidad" *ngFor="let elemento of getClaveUnidadFiltrado()" >{{elemento.descripcion}}</option>
                </datalist>
                <div class="invalid-feedback" *ngIf="sat_clave_unidad==''">Clave Unidad no puede estar vacío</div>
            </div>
        </div>
        <div class="col-md-4 mb-2">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">ClaveProdServ</span>
                <input type="text" class="form-control" [(ngModel)]="sat_claveprodserv" name="sat_claveprodserv" list="catalogo_claves_productos_servicios" aria-describedby="inputGroupPrepend2" [ngClass]="{'is-invalid': registroPublicacion.submitted && sat_claveprodserv == '' }"
                    required>
                <datalist id="catalogo_claves_productos_servicios">
                    <option [value]="elemento.clave_producto_servicio" *ngFor="let elemento of getClaveProductoervicioFiltrado()" >{{elemento.descripcion}}</option>
                </datalist>
                <div class="invalid-feedback" *ngIf="sat_claveprodserv==''">Clave Producto Servicio no puede estar vacío</div>
            </div>
        </div>
    </div>
    <div class="form-row ">
        <div class="col-md-4 mb-2">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">Precio U.</span>
                <input type="text" class="form-control" [(ngModel)]="precio_unitario" name="precio_unitario" aria-describedby="inputGroupPrepend2" [ngClass]="{'is-invalid': registroPublicacion.submitted && precio_unitario <= 0 }" required>
                <div class="invalid-feedback" *ngIf="precio_unitario <= 0">Precio Unitario debe ser mayor a 0</div>
            </div>
        </div>
        <div class="col-md-4 mb-2">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">IVA</span>
                <input type="checkbox" class="btn-check" id="btn-check-2-outlined" checked autocomplete="off" [(ngModel)]="aplica_iva" name="aplica_iva">
                <label class="btn btn-outline-success" for="btn-check-2-outlined" style="margin-bottom: 0;" ngbTooltip="Se aplica IVA al importe">{{aplica_iva ? "Si":"No"}}</label>

                <input type="checkbox" class="btn-check" id="btn-check-outlined" autocomplete="off" [(ngModel)]="incluye_iva" name="aplica_iva" *ngIf="aplica_iva">
                <label class="btn btn-outline-primary" for="btn-check-outlined" style="margin-bottom: 0;" ngbTooltip="El precio ya incluye IVA" *ngIf="aplica_iva">{{incluye_iva ? "":"No"}} Incluye IVA</label>
                <div class="invalid-feedback" *ngIf="precio_unitario <= 0">Precio Unitario debe ser mayor a 0</div>
            </div>
        </div>
        <div class="col-md-4 mb-2">
            <div class="input-group input-group-sm">
                <span class="input-group-text" style="width: 100px;">Importe</span>
                <input type="text" class="form-control" [(ngModel)]="importe" name="importe" value="{{(precio_unitario) | number:'1.2-2'}}" aria-describedby="inputGroupPrepend2" readonly>
                <div></div>
            </div>
        </div>
    </div>

    <div class="form-row">
        <div class="mb-2" *ngIf="posicion != -1">
            <div class="input-group input-group-sm">
                <button class="btn btn-danger" (click)="limpiar()">
                    Cancelar
                </button>
            </div>
        </div>
        &nbsp;
        <div class="mb-2">
            <div class="input-group input-group-sm">
                <button class="btn btn-primary">
                    {{this.posicion==-1 ? "Agregar Venta" : "Guardar" }}
                </button>
            </div>
        </div>
        &nbsp;
        <div class="mb-2" *ngIf="registro_publicaciones.length>0">
            <div class="input-group input-group-sm">
                <button class="btn btn-success" type="button" (click)="registrar()">
                    Registrar Venta
                </button>
            </div>
        </div>
    </div>

</form>

<div class="table-responsive" *ngIf="true">

    <div class="btn-toolbar" role="toolbar">
        <div class="table-responsive">

            <table [ngClass]="{'table':true,'table-hover': registro_publicaciones.length != 0}" id="tabla">
                <thead>
                    <tr>
                        <th><small><b>Acciones</b></small></th>
                        <th><small><b>#</b></small></th>
                        <th><small><b>Fecha Publicación</b></small></th>
                        <th><small><b>Plataforma</b></small></th>
                        <th><small><b>Titulo</b></small></th>
                        <th><small><b>Unidad</b></small></th>
                        <th><small><b>Precio Unitario</b></small></th>
                        <th><small><b>Importe</b></small></th>
                        <th><small><b>IVA</b></small></th>
                        <th><small><b>Total</b></small></th>
                    </tr>
                </thead>
                <tbody *ngIf="registro_publicaciones.length == 0">
                    <tr>
                        <td colspan="10" align="center">Sin Registros</td>
                    </tr>
                </tbody>
                <tbody>
                    <tr *ngFor="let publicacion of registro_publicaciones;let i=index ">
                        <td>
                            <button class="btn btn-danger btn-sm" (click)="eliminar(i)"><i class="bi bi-trash-fill"></i></button>
                            <button class="btn btn-primary btn-sm" (click)="modificar(i)"><i class="bi bi-pencil-square"></i></button>
                        </td>
                        <td><small>{{(i+1) | number}}</small></td>
                        <td align="right"><small>{{publicacion.fecha_publicacion | number}}</small></td>
                        <td><small>{{publicacion.plataforma_acronimo}}</small></td>
                        <td><small>{{publicacion.titulo}}</small></td>
                        <td><small>{{publicacion.unidad}}</small></td>
                        <td align="right"><small>{{publicacion.precio_unitario | currency}}</small></td>
                        <td align="right"><small>{{publicacion.importe | currency}}</small></td>
                        <td align="right"><small>{{publicacion.importe_iva | currency}}</small></td>
                        <td align="right"><small>{{publicacion.importe+publicacion.importe_iva | currency}}</small></td>
                    </tr>
                </tbody>
                <tr *ngIf="registro_publicaciones.length > 0">
                    <td></td>
                    <th colspan="5" style="text-align: right"><small><b>Subtotal</b></small></th>
                    <th style="text-align: right">{{getTotal("precio_unitario") | currency}}</th>
                    <th style="text-align: right">{{getTotal("importe") | currency}}</th>
                    <th style="text-align: right">{{getTotal("importe_iva") | currency}}</th>
                    <th style="text-align: right">{{getTotal("importe") + getTotal("importe_iva") | currency}}</th>
                    <!-- <th style="text-align: right">{{ registro_publicaciones.map(venta => venta.importe).reduce( (a, b) => a + b,0 ) }}</th> -->
                </tr>
            </table>
        </div>
    </div>
</div>